/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksBudgetPoliciesConfig extends cdktf.TerraformMetaArguments {
}
export interface DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies#key DataDatabricksBudgetPolicies#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies#value DataDatabricksBudgetPolicies#value}
    */
    readonly value?: string;
}
export declare function dataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsToTerraform(struct?: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags | cdktf.IResolvable): any;
export declare function dataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsToHclTerraform(struct?: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags | cdktf.IResolvable): any;
export declare class DataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class DataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsOutputReference;
}
export interface DataDatabricksBudgetPoliciesBudgetPolicies {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies#custom_tags DataDatabricksBudgetPolicies#custom_tags}
    */
    readonly customTags?: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies#policy_name DataDatabricksBudgetPolicies#policy_name}
    */
    readonly policyName?: string;
}
export declare function dataDatabricksBudgetPoliciesBudgetPoliciesToTerraform(struct?: DataDatabricksBudgetPoliciesBudgetPolicies): any;
export declare function dataDatabricksBudgetPoliciesBudgetPoliciesToHclTerraform(struct?: DataDatabricksBudgetPoliciesBudgetPolicies): any;
export declare class DataDatabricksBudgetPoliciesBudgetPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksBudgetPoliciesBudgetPolicies | undefined;
    set internalValue(value: DataDatabricksBudgetPoliciesBudgetPolicies | undefined);
    private _customTags;
    get customTags(): DataDatabricksBudgetPoliciesBudgetPoliciesCustomTagsList;
    putCustomTags(value: DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags[] | cdktf.IResolvable): void;
    resetCustomTags(): void;
    get customTagsInput(): cdktf.IResolvable | DataDatabricksBudgetPoliciesBudgetPoliciesCustomTags[] | undefined;
    get policyId(): string;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    resetPolicyName(): void;
    get policyNameInput(): string | undefined;
}
export declare class DataDatabricksBudgetPoliciesBudgetPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksBudgetPoliciesBudgetPolicies[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksBudgetPoliciesBudgetPoliciesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies databricks_budget_policies}
*/
export declare class DataDatabricksBudgetPolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_budget_policies";
    /**
    * Generates CDKTF code for importing a DataDatabricksBudgetPolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksBudgetPolicies to import
    * @param importFromId The id of the existing DataDatabricksBudgetPolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksBudgetPolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/budget_policies databricks_budget_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksBudgetPoliciesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksBudgetPoliciesConfig);
    private _budgetPolicies;
    get budgetPolicies(): DataDatabricksBudgetPoliciesBudgetPoliciesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
