/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksRegisteredModelConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#full_name DataDatabricksRegisteredModel#full_name}
    */
    readonly fullName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#include_aliases DataDatabricksRegisteredModel#include_aliases}
    */
    readonly includeAliases?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#include_browse DataDatabricksRegisteredModel#include_browse}
    */
    readonly includeBrowse?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#model_info DataDatabricksRegisteredModel#model_info}
    */
    readonly modelInfo?: DataDatabricksRegisteredModelModelInfo[] | cdktf.IResolvable;
}
export interface DataDatabricksRegisteredModelModelInfoAliases {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#alias_name DataDatabricksRegisteredModel#alias_name}
    */
    readonly aliasName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#version_num DataDatabricksRegisteredModel#version_num}
    */
    readonly versionNum?: number;
}
export declare function dataDatabricksRegisteredModelModelInfoAliasesToTerraform(struct?: DataDatabricksRegisteredModelModelInfoAliases | cdktf.IResolvable): any;
export declare function dataDatabricksRegisteredModelModelInfoAliasesToHclTerraform(struct?: DataDatabricksRegisteredModelModelInfoAliases | cdktf.IResolvable): any;
export declare class DataDatabricksRegisteredModelModelInfoAliasesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksRegisteredModelModelInfoAliases | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksRegisteredModelModelInfoAliases | cdktf.IResolvable | undefined);
    private _aliasName?;
    get aliasName(): string;
    set aliasName(value: string);
    resetAliasName(): void;
    get aliasNameInput(): string | undefined;
    private _versionNum?;
    get versionNum(): number;
    set versionNum(value: number);
    resetVersionNum(): void;
    get versionNumInput(): number | undefined;
}
export declare class DataDatabricksRegisteredModelModelInfoAliasesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksRegisteredModelModelInfoAliases[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksRegisteredModelModelInfoAliasesOutputReference;
}
export interface DataDatabricksRegisteredModelModelInfo {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#aliases DataDatabricksRegisteredModel#aliases}
    */
    readonly aliases?: DataDatabricksRegisteredModelModelInfoAliases[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#browse_only DataDatabricksRegisteredModel#browse_only}
    */
    readonly browseOnly?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#catalog_name DataDatabricksRegisteredModel#catalog_name}
    */
    readonly catalogName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#comment DataDatabricksRegisteredModel#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#created_at DataDatabricksRegisteredModel#created_at}
    */
    readonly createdAt?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#created_by DataDatabricksRegisteredModel#created_by}
    */
    readonly createdBy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#full_name DataDatabricksRegisteredModel#full_name}
    */
    readonly fullName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#metastore_id DataDatabricksRegisteredModel#metastore_id}
    */
    readonly metastoreId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#name DataDatabricksRegisteredModel#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#owner DataDatabricksRegisteredModel#owner}
    */
    readonly owner?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#schema_name DataDatabricksRegisteredModel#schema_name}
    */
    readonly schemaName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#storage_location DataDatabricksRegisteredModel#storage_location}
    */
    readonly storageLocation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#updated_at DataDatabricksRegisteredModel#updated_at}
    */
    readonly updatedAt?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#updated_by DataDatabricksRegisteredModel#updated_by}
    */
    readonly updatedBy?: string;
}
export declare function dataDatabricksRegisteredModelModelInfoToTerraform(struct?: DataDatabricksRegisteredModelModelInfo | cdktf.IResolvable): any;
export declare function dataDatabricksRegisteredModelModelInfoToHclTerraform(struct?: DataDatabricksRegisteredModelModelInfo | cdktf.IResolvable): any;
export declare class DataDatabricksRegisteredModelModelInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksRegisteredModelModelInfo | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksRegisteredModelModelInfo | cdktf.IResolvable | undefined);
    private _aliases;
    get aliases(): DataDatabricksRegisteredModelModelInfoAliasesList;
    putAliases(value: DataDatabricksRegisteredModelModelInfoAliases[] | cdktf.IResolvable): void;
    resetAliases(): void;
    get aliasesInput(): cdktf.IResolvable | DataDatabricksRegisteredModelModelInfoAliases[] | undefined;
    private _browseOnly?;
    get browseOnly(): boolean | cdktf.IResolvable;
    set browseOnly(value: boolean | cdktf.IResolvable);
    resetBrowseOnly(): void;
    get browseOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _catalogName?;
    get catalogName(): string;
    set catalogName(value: string);
    resetCatalogName(): void;
    get catalogNameInput(): string | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _createdAt?;
    get createdAt(): number;
    set createdAt(value: number);
    resetCreatedAt(): void;
    get createdAtInput(): number | undefined;
    private _createdBy?;
    get createdBy(): string;
    set createdBy(value: string);
    resetCreatedBy(): void;
    get createdByInput(): string | undefined;
    private _fullName?;
    get fullName(): string;
    set fullName(value: string);
    resetFullName(): void;
    get fullNameInput(): string | undefined;
    private _metastoreId?;
    get metastoreId(): string;
    set metastoreId(value: string);
    resetMetastoreId(): void;
    get metastoreIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _owner?;
    get owner(): string;
    set owner(value: string);
    resetOwner(): void;
    get ownerInput(): string | undefined;
    private _schemaName?;
    get schemaName(): string;
    set schemaName(value: string);
    resetSchemaName(): void;
    get schemaNameInput(): string | undefined;
    private _storageLocation?;
    get storageLocation(): string;
    set storageLocation(value: string);
    resetStorageLocation(): void;
    get storageLocationInput(): string | undefined;
    private _updatedAt?;
    get updatedAt(): number;
    set updatedAt(value: number);
    resetUpdatedAt(): void;
    get updatedAtInput(): number | undefined;
    private _updatedBy?;
    get updatedBy(): string;
    set updatedBy(value: string);
    resetUpdatedBy(): void;
    get updatedByInput(): string | undefined;
}
export declare class DataDatabricksRegisteredModelModelInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksRegisteredModelModelInfo[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksRegisteredModelModelInfoOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model databricks_registered_model}
*/
export declare class DataDatabricksRegisteredModel extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_registered_model";
    /**
    * Generates CDKTF code for importing a DataDatabricksRegisteredModel resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksRegisteredModel to import
    * @param importFromId The id of the existing DataDatabricksRegisteredModel that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksRegisteredModel to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/registered_model databricks_registered_model} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksRegisteredModelConfig
    */
    constructor(scope: Construct, id: string, config: DataDatabricksRegisteredModelConfig);
    private _fullName?;
    get fullName(): string;
    set fullName(value: string);
    get fullNameInput(): string | undefined;
    private _includeAliases?;
    get includeAliases(): boolean | cdktf.IResolvable;
    set includeAliases(value: boolean | cdktf.IResolvable);
    resetIncludeAliases(): void;
    get includeAliasesInput(): boolean | cdktf.IResolvable | undefined;
    private _includeBrowse?;
    get includeBrowse(): boolean | cdktf.IResolvable;
    set includeBrowse(value: boolean | cdktf.IResolvable);
    resetIncludeBrowse(): void;
    get includeBrowseInput(): boolean | cdktf.IResolvable | undefined;
    private _modelInfo;
    get modelInfo(): DataDatabricksRegisteredModelModelInfoList;
    putModelInfo(value: DataDatabricksRegisteredModelModelInfo[] | cdktf.IResolvable): void;
    resetModelInfo(): void;
    get modelInfoInput(): cdktf.IResolvable | DataDatabricksRegisteredModelModelInfo[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
