/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksSharesPluginframeworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/shares_pluginframework#shares DataDatabricksSharesPluginframework#shares}
    */
    readonly shares?: string[];
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/shares_pluginframework databricks_shares_pluginframework}
*/
export declare class DataDatabricksSharesPluginframework extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_shares_pluginframework";
    /**
    * Generates CDKTF code for importing a DataDatabricksSharesPluginframework resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksSharesPluginframework to import
    * @param importFromId The id of the existing DataDatabricksSharesPluginframework that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/shares_pluginframework#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksSharesPluginframework to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/data-sources/shares_pluginframework databricks_shares_pluginframework} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksSharesPluginframeworkConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksSharesPluginframeworkConfig);
    private _shares?;
    get shares(): string[];
    set shares(value: string[]);
    resetShares(): void;
    get sharesInput(): string[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
