/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface PipelineConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#allow_duplicate_names Pipeline#allow_duplicate_names}
    */
    readonly allowDuplicateNames?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#budget_policy_id Pipeline#budget_policy_id}
    */
    readonly budgetPolicyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#catalog Pipeline#catalog}
    */
    readonly catalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#cause Pipeline#cause}
    */
    readonly cause?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#channel Pipeline#channel}
    */
    readonly channel?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#cluster_id Pipeline#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#configuration Pipeline#configuration}
    */
    readonly configuration?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#continuous Pipeline#continuous}
    */
    readonly continuous?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#creator_user_name Pipeline#creator_user_name}
    */
    readonly creatorUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#development Pipeline#development}
    */
    readonly development?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#edition Pipeline#edition}
    */
    readonly edition?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#expected_last_modified Pipeline#expected_last_modified}
    */
    readonly expectedLastModified?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#health Pipeline#health}
    */
    readonly health?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#id Pipeline#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#last_modified Pipeline#last_modified}
    */
    readonly lastModified?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#name Pipeline#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#photon Pipeline#photon}
    */
    readonly photon?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#run_as_user_name Pipeline#run_as_user_name}
    */
    readonly runAsUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#schema Pipeline#schema}
    */
    readonly schema?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#serverless Pipeline#serverless}
    */
    readonly serverless?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#state Pipeline#state}
    */
    readonly state?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#storage Pipeline#storage}
    */
    readonly storage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#target Pipeline#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#url Pipeline#url}
    */
    readonly url?: string;
    /**
    * cluster block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#cluster Pipeline#cluster}
    */
    readonly cluster?: PipelineCluster[] | cdktf.IResolvable;
    /**
    * deployment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#deployment Pipeline#deployment}
    */
    readonly deployment?: PipelineDeployment;
    /**
    * event_log block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#event_log Pipeline#event_log}
    */
    readonly eventLog?: PipelineEventLog;
    /**
    * filters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#filters Pipeline#filters}
    */
    readonly filters?: PipelineFilters;
    /**
    * gateway_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gateway_definition Pipeline#gateway_definition}
    */
    readonly gatewayDefinition?: PipelineGatewayDefinition;
    /**
    * ingestion_definition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ingestion_definition Pipeline#ingestion_definition}
    */
    readonly ingestionDefinition?: PipelineIngestionDefinition;
    /**
    * latest_updates block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#latest_updates Pipeline#latest_updates}
    */
    readonly latestUpdates?: PipelineLatestUpdates[] | cdktf.IResolvable;
    /**
    * library block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#library Pipeline#library}
    */
    readonly library?: PipelineLibrary[] | cdktf.IResolvable;
    /**
    * notification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#notification Pipeline#notification}
    */
    readonly notification?: PipelineNotification[] | cdktf.IResolvable;
    /**
    * restart_window block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#restart_window Pipeline#restart_window}
    */
    readonly restartWindow?: PipelineRestartWindow;
    /**
    * run_as block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#run_as Pipeline#run_as}
    */
    readonly runAs?: PipelineRunAs;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#timeouts Pipeline#timeouts}
    */
    readonly timeouts?: PipelineTimeouts;
    /**
    * trigger block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#trigger Pipeline#trigger}
    */
    readonly trigger?: PipelineTrigger;
}
export interface PipelineClusterAutoscale {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#max_workers Pipeline#max_workers}
    */
    readonly maxWorkers: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#min_workers Pipeline#min_workers}
    */
    readonly minWorkers: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#mode Pipeline#mode}
    */
    readonly mode?: string;
}
export declare function pipelineClusterAutoscaleToTerraform(struct?: PipelineClusterAutoscaleOutputReference | PipelineClusterAutoscale): any;
export declare function pipelineClusterAutoscaleToHclTerraform(struct?: PipelineClusterAutoscaleOutputReference | PipelineClusterAutoscale): any;
export declare class PipelineClusterAutoscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterAutoscale | undefined;
    set internalValue(value: PipelineClusterAutoscale | undefined);
    private _maxWorkers?;
    get maxWorkers(): number;
    set maxWorkers(value: number);
    get maxWorkersInput(): number | undefined;
    private _minWorkers?;
    get minWorkers(): number;
    set minWorkers(value: number);
    get minWorkersInput(): number | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
}
export interface PipelineClusterAwsAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#availability Pipeline#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ebs_volume_count Pipeline#ebs_volume_count}
    */
    readonly ebsVolumeCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ebs_volume_iops Pipeline#ebs_volume_iops}
    */
    readonly ebsVolumeIops?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ebs_volume_size Pipeline#ebs_volume_size}
    */
    readonly ebsVolumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ebs_volume_throughput Pipeline#ebs_volume_throughput}
    */
    readonly ebsVolumeThroughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ebs_volume_type Pipeline#ebs_volume_type}
    */
    readonly ebsVolumeType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#first_on_demand Pipeline#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#instance_profile_arn Pipeline#instance_profile_arn}
    */
    readonly instanceProfileArn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#spot_bid_price_percent Pipeline#spot_bid_price_percent}
    */
    readonly spotBidPricePercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#zone_id Pipeline#zone_id}
    */
    readonly zoneId?: string;
}
export declare function pipelineClusterAwsAttributesToTerraform(struct?: PipelineClusterAwsAttributesOutputReference | PipelineClusterAwsAttributes): any;
export declare function pipelineClusterAwsAttributesToHclTerraform(struct?: PipelineClusterAwsAttributesOutputReference | PipelineClusterAwsAttributes): any;
export declare class PipelineClusterAwsAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterAwsAttributes | undefined;
    set internalValue(value: PipelineClusterAwsAttributes | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _ebsVolumeCount?;
    get ebsVolumeCount(): number;
    set ebsVolumeCount(value: number);
    resetEbsVolumeCount(): void;
    get ebsVolumeCountInput(): number | undefined;
    private _ebsVolumeIops?;
    get ebsVolumeIops(): number;
    set ebsVolumeIops(value: number);
    resetEbsVolumeIops(): void;
    get ebsVolumeIopsInput(): number | undefined;
    private _ebsVolumeSize?;
    get ebsVolumeSize(): number;
    set ebsVolumeSize(value: number);
    resetEbsVolumeSize(): void;
    get ebsVolumeSizeInput(): number | undefined;
    private _ebsVolumeThroughput?;
    get ebsVolumeThroughput(): number;
    set ebsVolumeThroughput(value: number);
    resetEbsVolumeThroughput(): void;
    get ebsVolumeThroughputInput(): number | undefined;
    private _ebsVolumeType?;
    get ebsVolumeType(): string;
    set ebsVolumeType(value: string);
    resetEbsVolumeType(): void;
    get ebsVolumeTypeInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _instanceProfileArn?;
    get instanceProfileArn(): string;
    set instanceProfileArn(value: string);
    resetInstanceProfileArn(): void;
    get instanceProfileArnInput(): string | undefined;
    private _spotBidPricePercent?;
    get spotBidPricePercent(): number;
    set spotBidPricePercent(value: number);
    resetSpotBidPricePercent(): void;
    get spotBidPricePercentInput(): number | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export interface PipelineClusterAzureAttributesLogAnalyticsInfo {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#log_analytics_primary_key Pipeline#log_analytics_primary_key}
    */
    readonly logAnalyticsPrimaryKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#log_analytics_workspace_id Pipeline#log_analytics_workspace_id}
    */
    readonly logAnalyticsWorkspaceId?: string;
}
export declare function pipelineClusterAzureAttributesLogAnalyticsInfoToTerraform(struct?: PipelineClusterAzureAttributesLogAnalyticsInfoOutputReference | PipelineClusterAzureAttributesLogAnalyticsInfo): any;
export declare function pipelineClusterAzureAttributesLogAnalyticsInfoToHclTerraform(struct?: PipelineClusterAzureAttributesLogAnalyticsInfoOutputReference | PipelineClusterAzureAttributesLogAnalyticsInfo): any;
export declare class PipelineClusterAzureAttributesLogAnalyticsInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterAzureAttributesLogAnalyticsInfo | undefined;
    set internalValue(value: PipelineClusterAzureAttributesLogAnalyticsInfo | undefined);
    private _logAnalyticsPrimaryKey?;
    get logAnalyticsPrimaryKey(): string;
    set logAnalyticsPrimaryKey(value: string);
    resetLogAnalyticsPrimaryKey(): void;
    get logAnalyticsPrimaryKeyInput(): string | undefined;
    private _logAnalyticsWorkspaceId?;
    get logAnalyticsWorkspaceId(): string;
    set logAnalyticsWorkspaceId(value: string);
    resetLogAnalyticsWorkspaceId(): void;
    get logAnalyticsWorkspaceIdInput(): string | undefined;
}
export interface PipelineClusterAzureAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#availability Pipeline#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#first_on_demand Pipeline#first_on_demand}
    */
    readonly firstOnDemand?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#spot_bid_max_price Pipeline#spot_bid_max_price}
    */
    readonly spotBidMaxPrice?: number;
    /**
    * log_analytics_info block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#log_analytics_info Pipeline#log_analytics_info}
    */
    readonly logAnalyticsInfo?: PipelineClusterAzureAttributesLogAnalyticsInfo;
}
export declare function pipelineClusterAzureAttributesToTerraform(struct?: PipelineClusterAzureAttributesOutputReference | PipelineClusterAzureAttributes): any;
export declare function pipelineClusterAzureAttributesToHclTerraform(struct?: PipelineClusterAzureAttributesOutputReference | PipelineClusterAzureAttributes): any;
export declare class PipelineClusterAzureAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterAzureAttributes | undefined;
    set internalValue(value: PipelineClusterAzureAttributes | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _firstOnDemand?;
    get firstOnDemand(): number;
    set firstOnDemand(value: number);
    resetFirstOnDemand(): void;
    get firstOnDemandInput(): number | undefined;
    private _spotBidMaxPrice?;
    get spotBidMaxPrice(): number;
    set spotBidMaxPrice(value: number);
    resetSpotBidMaxPrice(): void;
    get spotBidMaxPriceInput(): number | undefined;
    private _logAnalyticsInfo;
    get logAnalyticsInfo(): PipelineClusterAzureAttributesLogAnalyticsInfoOutputReference;
    putLogAnalyticsInfo(value: PipelineClusterAzureAttributesLogAnalyticsInfo): void;
    resetLogAnalyticsInfo(): void;
    get logAnalyticsInfoInput(): PipelineClusterAzureAttributesLogAnalyticsInfo | undefined;
}
export interface PipelineClusterClusterLogConfDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterClusterLogConfDbfsToTerraform(struct?: PipelineClusterClusterLogConfDbfsOutputReference | PipelineClusterClusterLogConfDbfs): any;
export declare function pipelineClusterClusterLogConfDbfsToHclTerraform(struct?: PipelineClusterClusterLogConfDbfsOutputReference | PipelineClusterClusterLogConfDbfs): any;
export declare class PipelineClusterClusterLogConfDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterClusterLogConfDbfs | undefined;
    set internalValue(value: PipelineClusterClusterLogConfDbfs | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterClusterLogConfS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#canned_acl Pipeline#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#enable_encryption Pipeline#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#encryption_type Pipeline#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#endpoint Pipeline#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#kms_key Pipeline#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#region Pipeline#region}
    */
    readonly region?: string;
}
export declare function pipelineClusterClusterLogConfS3ToTerraform(struct?: PipelineClusterClusterLogConfS3OutputReference | PipelineClusterClusterLogConfS3): any;
export declare function pipelineClusterClusterLogConfS3ToHclTerraform(struct?: PipelineClusterClusterLogConfS3OutputReference | PipelineClusterClusterLogConfS3): any;
export declare class PipelineClusterClusterLogConfS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterClusterLogConfS3 | undefined;
    set internalValue(value: PipelineClusterClusterLogConfS3 | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export interface PipelineClusterClusterLogConfVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterClusterLogConfVolumesToTerraform(struct?: PipelineClusterClusterLogConfVolumesOutputReference | PipelineClusterClusterLogConfVolumes): any;
export declare function pipelineClusterClusterLogConfVolumesToHclTerraform(struct?: PipelineClusterClusterLogConfVolumesOutputReference | PipelineClusterClusterLogConfVolumes): any;
export declare class PipelineClusterClusterLogConfVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterClusterLogConfVolumes | undefined;
    set internalValue(value: PipelineClusterClusterLogConfVolumes | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterClusterLogConf {
    /**
    * dbfs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#dbfs Pipeline#dbfs}
    */
    readonly dbfs?: PipelineClusterClusterLogConfDbfs;
    /**
    * s3 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#s3 Pipeline#s3}
    */
    readonly s3?: PipelineClusterClusterLogConfS3;
    /**
    * volumes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#volumes Pipeline#volumes}
    */
    readonly volumes?: PipelineClusterClusterLogConfVolumes;
}
export declare function pipelineClusterClusterLogConfToTerraform(struct?: PipelineClusterClusterLogConfOutputReference | PipelineClusterClusterLogConf): any;
export declare function pipelineClusterClusterLogConfToHclTerraform(struct?: PipelineClusterClusterLogConfOutputReference | PipelineClusterClusterLogConf): any;
export declare class PipelineClusterClusterLogConfOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterClusterLogConf | undefined;
    set internalValue(value: PipelineClusterClusterLogConf | undefined);
    private _dbfs;
    get dbfs(): PipelineClusterClusterLogConfDbfsOutputReference;
    putDbfs(value: PipelineClusterClusterLogConfDbfs): void;
    resetDbfs(): void;
    get dbfsInput(): PipelineClusterClusterLogConfDbfs | undefined;
    private _s3;
    get s3(): PipelineClusterClusterLogConfS3OutputReference;
    putS3(value: PipelineClusterClusterLogConfS3): void;
    resetS3(): void;
    get s3Input(): PipelineClusterClusterLogConfS3 | undefined;
    private _volumes;
    get volumes(): PipelineClusterClusterLogConfVolumesOutputReference;
    putVolumes(value: PipelineClusterClusterLogConfVolumes): void;
    resetVolumes(): void;
    get volumesInput(): PipelineClusterClusterLogConfVolumes | undefined;
}
export interface PipelineClusterGcpAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#availability Pipeline#availability}
    */
    readonly availability?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#google_service_account Pipeline#google_service_account}
    */
    readonly googleServiceAccount?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#local_ssd_count Pipeline#local_ssd_count}
    */
    readonly localSsdCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#zone_id Pipeline#zone_id}
    */
    readonly zoneId?: string;
}
export declare function pipelineClusterGcpAttributesToTerraform(struct?: PipelineClusterGcpAttributesOutputReference | PipelineClusterGcpAttributes): any;
export declare function pipelineClusterGcpAttributesToHclTerraform(struct?: PipelineClusterGcpAttributesOutputReference | PipelineClusterGcpAttributes): any;
export declare class PipelineClusterGcpAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterGcpAttributes | undefined;
    set internalValue(value: PipelineClusterGcpAttributes | undefined);
    private _availability?;
    get availability(): string;
    set availability(value: string);
    resetAvailability(): void;
    get availabilityInput(): string | undefined;
    private _googleServiceAccount?;
    get googleServiceAccount(): string;
    set googleServiceAccount(value: string);
    resetGoogleServiceAccount(): void;
    get googleServiceAccountInput(): string | undefined;
    private _localSsdCount?;
    get localSsdCount(): number;
    set localSsdCount(value: number);
    resetLocalSsdCount(): void;
    get localSsdCountInput(): number | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export interface PipelineClusterInitScriptsAbfss {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsAbfssToTerraform(struct?: PipelineClusterInitScriptsAbfssOutputReference | PipelineClusterInitScriptsAbfss): any;
export declare function pipelineClusterInitScriptsAbfssToHclTerraform(struct?: PipelineClusterInitScriptsAbfssOutputReference | PipelineClusterInitScriptsAbfss): any;
export declare class PipelineClusterInitScriptsAbfssOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsAbfss | undefined;
    set internalValue(value: PipelineClusterInitScriptsAbfss | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScriptsDbfs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsDbfsToTerraform(struct?: PipelineClusterInitScriptsDbfsOutputReference | PipelineClusterInitScriptsDbfs): any;
export declare function pipelineClusterInitScriptsDbfsToHclTerraform(struct?: PipelineClusterInitScriptsDbfsOutputReference | PipelineClusterInitScriptsDbfs): any;
export declare class PipelineClusterInitScriptsDbfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsDbfs | undefined;
    set internalValue(value: PipelineClusterInitScriptsDbfs | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScriptsFile {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsFileToTerraform(struct?: PipelineClusterInitScriptsFileOutputReference | PipelineClusterInitScriptsFile): any;
export declare function pipelineClusterInitScriptsFileToHclTerraform(struct?: PipelineClusterInitScriptsFileOutputReference | PipelineClusterInitScriptsFile): any;
export declare class PipelineClusterInitScriptsFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsFile | undefined;
    set internalValue(value: PipelineClusterInitScriptsFile | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScriptsGcs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsGcsToTerraform(struct?: PipelineClusterInitScriptsGcsOutputReference | PipelineClusterInitScriptsGcs): any;
export declare function pipelineClusterInitScriptsGcsToHclTerraform(struct?: PipelineClusterInitScriptsGcsOutputReference | PipelineClusterInitScriptsGcs): any;
export declare class PipelineClusterInitScriptsGcsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsGcs | undefined;
    set internalValue(value: PipelineClusterInitScriptsGcs | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScriptsS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#canned_acl Pipeline#canned_acl}
    */
    readonly cannedAcl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#enable_encryption Pipeline#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#encryption_type Pipeline#encryption_type}
    */
    readonly encryptionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#endpoint Pipeline#endpoint}
    */
    readonly endpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#kms_key Pipeline#kms_key}
    */
    readonly kmsKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#region Pipeline#region}
    */
    readonly region?: string;
}
export declare function pipelineClusterInitScriptsS3ToTerraform(struct?: PipelineClusterInitScriptsS3OutputReference | PipelineClusterInitScriptsS3): any;
export declare function pipelineClusterInitScriptsS3ToHclTerraform(struct?: PipelineClusterInitScriptsS3OutputReference | PipelineClusterInitScriptsS3): any;
export declare class PipelineClusterInitScriptsS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsS3 | undefined;
    set internalValue(value: PipelineClusterInitScriptsS3 | undefined);
    private _cannedAcl?;
    get cannedAcl(): string;
    set cannedAcl(value: string);
    resetCannedAcl(): void;
    get cannedAclInput(): string | undefined;
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionType?;
    get encryptionType(): string;
    set encryptionType(value: string);
    resetEncryptionType(): void;
    get encryptionTypeInput(): string | undefined;
    private _endpoint?;
    get endpoint(): string;
    set endpoint(value: string);
    resetEndpoint(): void;
    get endpointInput(): string | undefined;
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    resetKmsKey(): void;
    get kmsKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export interface PipelineClusterInitScriptsVolumes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsVolumesToTerraform(struct?: PipelineClusterInitScriptsVolumesOutputReference | PipelineClusterInitScriptsVolumes): any;
export declare function pipelineClusterInitScriptsVolumesToHclTerraform(struct?: PipelineClusterInitScriptsVolumesOutputReference | PipelineClusterInitScriptsVolumes): any;
export declare class PipelineClusterInitScriptsVolumesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsVolumes | undefined;
    set internalValue(value: PipelineClusterInitScriptsVolumes | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScriptsWorkspace {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination Pipeline#destination}
    */
    readonly destination: string;
}
export declare function pipelineClusterInitScriptsWorkspaceToTerraform(struct?: PipelineClusterInitScriptsWorkspaceOutputReference | PipelineClusterInitScriptsWorkspace): any;
export declare function pipelineClusterInitScriptsWorkspaceToHclTerraform(struct?: PipelineClusterInitScriptsWorkspaceOutputReference | PipelineClusterInitScriptsWorkspace): any;
export declare class PipelineClusterInitScriptsWorkspaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineClusterInitScriptsWorkspace | undefined;
    set internalValue(value: PipelineClusterInitScriptsWorkspace | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    get destinationInput(): string | undefined;
}
export interface PipelineClusterInitScripts {
    /**
    * abfss block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#abfss Pipeline#abfss}
    */
    readonly abfss?: PipelineClusterInitScriptsAbfss;
    /**
    * dbfs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#dbfs Pipeline#dbfs}
    */
    readonly dbfs?: PipelineClusterInitScriptsDbfs;
    /**
    * file block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#file Pipeline#file}
    */
    readonly file?: PipelineClusterInitScriptsFile;
    /**
    * gcs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gcs Pipeline#gcs}
    */
    readonly gcs?: PipelineClusterInitScriptsGcs;
    /**
    * s3 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#s3 Pipeline#s3}
    */
    readonly s3?: PipelineClusterInitScriptsS3;
    /**
    * volumes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#volumes Pipeline#volumes}
    */
    readonly volumes?: PipelineClusterInitScriptsVolumes;
    /**
    * workspace block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#workspace Pipeline#workspace}
    */
    readonly workspace?: PipelineClusterInitScriptsWorkspace;
}
export declare function pipelineClusterInitScriptsToTerraform(struct?: PipelineClusterInitScripts | cdktf.IResolvable): any;
export declare function pipelineClusterInitScriptsToHclTerraform(struct?: PipelineClusterInitScripts | cdktf.IResolvable): any;
export declare class PipelineClusterInitScriptsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineClusterInitScripts | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineClusterInitScripts | cdktf.IResolvable | undefined);
    private _abfss;
    get abfss(): PipelineClusterInitScriptsAbfssOutputReference;
    putAbfss(value: PipelineClusterInitScriptsAbfss): void;
    resetAbfss(): void;
    get abfssInput(): PipelineClusterInitScriptsAbfss | undefined;
    private _dbfs;
    get dbfs(): PipelineClusterInitScriptsDbfsOutputReference;
    putDbfs(value: PipelineClusterInitScriptsDbfs): void;
    resetDbfs(): void;
    get dbfsInput(): PipelineClusterInitScriptsDbfs | undefined;
    private _file;
    get file(): PipelineClusterInitScriptsFileOutputReference;
    putFile(value: PipelineClusterInitScriptsFile): void;
    resetFile(): void;
    get fileInput(): PipelineClusterInitScriptsFile | undefined;
    private _gcs;
    get gcs(): PipelineClusterInitScriptsGcsOutputReference;
    putGcs(value: PipelineClusterInitScriptsGcs): void;
    resetGcs(): void;
    get gcsInput(): PipelineClusterInitScriptsGcs | undefined;
    private _s3;
    get s3(): PipelineClusterInitScriptsS3OutputReference;
    putS3(value: PipelineClusterInitScriptsS3): void;
    resetS3(): void;
    get s3Input(): PipelineClusterInitScriptsS3 | undefined;
    private _volumes;
    get volumes(): PipelineClusterInitScriptsVolumesOutputReference;
    putVolumes(value: PipelineClusterInitScriptsVolumes): void;
    resetVolumes(): void;
    get volumesInput(): PipelineClusterInitScriptsVolumes | undefined;
    private _workspace;
    get workspace(): PipelineClusterInitScriptsWorkspaceOutputReference;
    putWorkspace(value: PipelineClusterInitScriptsWorkspace): void;
    resetWorkspace(): void;
    get workspaceInput(): PipelineClusterInitScriptsWorkspace | undefined;
}
export declare class PipelineClusterInitScriptsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineClusterInitScripts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineClusterInitScriptsOutputReference;
}
export interface PipelineCluster {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#apply_policy_default_values Pipeline#apply_policy_default_values}
    */
    readonly applyPolicyDefaultValues?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#custom_tags Pipeline#custom_tags}
    */
    readonly customTags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#driver_instance_pool_id Pipeline#driver_instance_pool_id}
    */
    readonly driverInstancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#driver_node_type_id Pipeline#driver_node_type_id}
    */
    readonly driverNodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#enable_local_disk_encryption Pipeline#enable_local_disk_encryption}
    */
    readonly enableLocalDiskEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#instance_pool_id Pipeline#instance_pool_id}
    */
    readonly instancePoolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#label Pipeline#label}
    */
    readonly label?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#node_type_id Pipeline#node_type_id}
    */
    readonly nodeTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#num_workers Pipeline#num_workers}
    */
    readonly numWorkers?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#policy_id Pipeline#policy_id}
    */
    readonly policyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#spark_conf Pipeline#spark_conf}
    */
    readonly sparkConf?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#spark_env_vars Pipeline#spark_env_vars}
    */
    readonly sparkEnvVars?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ssh_public_keys Pipeline#ssh_public_keys}
    */
    readonly sshPublicKeys?: string[];
    /**
    * autoscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#autoscale Pipeline#autoscale}
    */
    readonly autoscale?: PipelineClusterAutoscale;
    /**
    * aws_attributes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#aws_attributes Pipeline#aws_attributes}
    */
    readonly awsAttributes?: PipelineClusterAwsAttributes;
    /**
    * azure_attributes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#azure_attributes Pipeline#azure_attributes}
    */
    readonly azureAttributes?: PipelineClusterAzureAttributes;
    /**
    * cluster_log_conf block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#cluster_log_conf Pipeline#cluster_log_conf}
    */
    readonly clusterLogConf?: PipelineClusterClusterLogConf;
    /**
    * gcp_attributes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gcp_attributes Pipeline#gcp_attributes}
    */
    readonly gcpAttributes?: PipelineClusterGcpAttributes;
    /**
    * init_scripts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#init_scripts Pipeline#init_scripts}
    */
    readonly initScripts?: PipelineClusterInitScripts[] | cdktf.IResolvable;
}
export declare function pipelineClusterToTerraform(struct?: PipelineCluster | cdktf.IResolvable): any;
export declare function pipelineClusterToHclTerraform(struct?: PipelineCluster | cdktf.IResolvable): any;
export declare class PipelineClusterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineCluster | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineCluster | cdktf.IResolvable | undefined);
    private _applyPolicyDefaultValues?;
    get applyPolicyDefaultValues(): boolean | cdktf.IResolvable;
    set applyPolicyDefaultValues(value: boolean | cdktf.IResolvable);
    resetApplyPolicyDefaultValues(): void;
    get applyPolicyDefaultValuesInput(): boolean | cdktf.IResolvable | undefined;
    private _customTags?;
    get customTags(): {
        [key: string]: string;
    };
    set customTags(value: {
        [key: string]: string;
    });
    resetCustomTags(): void;
    get customTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _driverInstancePoolId?;
    get driverInstancePoolId(): string;
    set driverInstancePoolId(value: string);
    resetDriverInstancePoolId(): void;
    get driverInstancePoolIdInput(): string | undefined;
    private _driverNodeTypeId?;
    get driverNodeTypeId(): string;
    set driverNodeTypeId(value: string);
    resetDriverNodeTypeId(): void;
    get driverNodeTypeIdInput(): string | undefined;
    private _enableLocalDiskEncryption?;
    get enableLocalDiskEncryption(): boolean | cdktf.IResolvable;
    set enableLocalDiskEncryption(value: boolean | cdktf.IResolvable);
    resetEnableLocalDiskEncryption(): void;
    get enableLocalDiskEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _instancePoolId?;
    get instancePoolId(): string;
    set instancePoolId(value: string);
    resetInstancePoolId(): void;
    get instancePoolIdInput(): string | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _nodeTypeId?;
    get nodeTypeId(): string;
    set nodeTypeId(value: string);
    resetNodeTypeId(): void;
    get nodeTypeIdInput(): string | undefined;
    private _numWorkers?;
    get numWorkers(): number;
    set numWorkers(value: number);
    resetNumWorkers(): void;
    get numWorkersInput(): number | undefined;
    private _policyId?;
    get policyId(): string;
    set policyId(value: string);
    resetPolicyId(): void;
    get policyIdInput(): string | undefined;
    private _sparkConf?;
    get sparkConf(): {
        [key: string]: string;
    };
    set sparkConf(value: {
        [key: string]: string;
    });
    resetSparkConf(): void;
    get sparkConfInput(): {
        [key: string]: string;
    } | undefined;
    private _sparkEnvVars?;
    get sparkEnvVars(): {
        [key: string]: string;
    };
    set sparkEnvVars(value: {
        [key: string]: string;
    });
    resetSparkEnvVars(): void;
    get sparkEnvVarsInput(): {
        [key: string]: string;
    } | undefined;
    private _sshPublicKeys?;
    get sshPublicKeys(): string[];
    set sshPublicKeys(value: string[]);
    resetSshPublicKeys(): void;
    get sshPublicKeysInput(): string[] | undefined;
    private _autoscale;
    get autoscale(): PipelineClusterAutoscaleOutputReference;
    putAutoscale(value: PipelineClusterAutoscale): void;
    resetAutoscale(): void;
    get autoscaleInput(): PipelineClusterAutoscale | undefined;
    private _awsAttributes;
    get awsAttributes(): PipelineClusterAwsAttributesOutputReference;
    putAwsAttributes(value: PipelineClusterAwsAttributes): void;
    resetAwsAttributes(): void;
    get awsAttributesInput(): PipelineClusterAwsAttributes | undefined;
    private _azureAttributes;
    get azureAttributes(): PipelineClusterAzureAttributesOutputReference;
    putAzureAttributes(value: PipelineClusterAzureAttributes): void;
    resetAzureAttributes(): void;
    get azureAttributesInput(): PipelineClusterAzureAttributes | undefined;
    private _clusterLogConf;
    get clusterLogConf(): PipelineClusterClusterLogConfOutputReference;
    putClusterLogConf(value: PipelineClusterClusterLogConf): void;
    resetClusterLogConf(): void;
    get clusterLogConfInput(): PipelineClusterClusterLogConf | undefined;
    private _gcpAttributes;
    get gcpAttributes(): PipelineClusterGcpAttributesOutputReference;
    putGcpAttributes(value: PipelineClusterGcpAttributes): void;
    resetGcpAttributes(): void;
    get gcpAttributesInput(): PipelineClusterGcpAttributes | undefined;
    private _initScripts;
    get initScripts(): PipelineClusterInitScriptsList;
    putInitScripts(value: PipelineClusterInitScripts[] | cdktf.IResolvable): void;
    resetInitScripts(): void;
    get initScriptsInput(): cdktf.IResolvable | PipelineClusterInitScripts[] | undefined;
}
export declare class PipelineClusterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineCluster[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineClusterOutputReference;
}
export interface PipelineDeployment {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#kind Pipeline#kind}
    */
    readonly kind?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#metadata_file_path Pipeline#metadata_file_path}
    */
    readonly metadataFilePath?: string;
}
export declare function pipelineDeploymentToTerraform(struct?: PipelineDeploymentOutputReference | PipelineDeployment): any;
export declare function pipelineDeploymentToHclTerraform(struct?: PipelineDeploymentOutputReference | PipelineDeployment): any;
export declare class PipelineDeploymentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineDeployment | undefined;
    set internalValue(value: PipelineDeployment | undefined);
    private _kind?;
    get kind(): string;
    set kind(value: string);
    resetKind(): void;
    get kindInput(): string | undefined;
    private _metadataFilePath?;
    get metadataFilePath(): string;
    set metadataFilePath(value: string);
    resetMetadataFilePath(): void;
    get metadataFilePathInput(): string | undefined;
}
export interface PipelineEventLog {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#catalog Pipeline#catalog}
    */
    readonly catalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#name Pipeline#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#schema Pipeline#schema}
    */
    readonly schema?: string;
}
export declare function pipelineEventLogToTerraform(struct?: PipelineEventLogOutputReference | PipelineEventLog): any;
export declare function pipelineEventLogToHclTerraform(struct?: PipelineEventLogOutputReference | PipelineEventLog): any;
export declare class PipelineEventLogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineEventLog | undefined;
    set internalValue(value: PipelineEventLog | undefined);
    private _catalog?;
    get catalog(): string;
    set catalog(value: string);
    resetCatalog(): void;
    get catalogInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _schema?;
    get schema(): string;
    set schema(value: string);
    resetSchema(): void;
    get schemaInput(): string | undefined;
}
export interface PipelineFilters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#exclude Pipeline#exclude}
    */
    readonly exclude?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#include Pipeline#include}
    */
    readonly include?: string[];
}
export declare function pipelineFiltersToTerraform(struct?: PipelineFiltersOutputReference | PipelineFilters): any;
export declare function pipelineFiltersToHclTerraform(struct?: PipelineFiltersOutputReference | PipelineFilters): any;
export declare class PipelineFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineFilters | undefined;
    set internalValue(value: PipelineFilters | undefined);
    private _exclude?;
    get exclude(): string[];
    set exclude(value: string[]);
    resetExclude(): void;
    get excludeInput(): string[] | undefined;
    private _include?;
    get include(): string[];
    set include(value: string[]);
    resetInclude(): void;
    get includeInput(): string[] | undefined;
}
export interface PipelineGatewayDefinition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#connection_id Pipeline#connection_id}
    */
    readonly connectionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#connection_name Pipeline#connection_name}
    */
    readonly connectionName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gateway_storage_catalog Pipeline#gateway_storage_catalog}
    */
    readonly gatewayStorageCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gateway_storage_name Pipeline#gateway_storage_name}
    */
    readonly gatewayStorageName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#gateway_storage_schema Pipeline#gateway_storage_schema}
    */
    readonly gatewayStorageSchema?: string;
}
export declare function pipelineGatewayDefinitionToTerraform(struct?: PipelineGatewayDefinitionOutputReference | PipelineGatewayDefinition): any;
export declare function pipelineGatewayDefinitionToHclTerraform(struct?: PipelineGatewayDefinitionOutputReference | PipelineGatewayDefinition): any;
export declare class PipelineGatewayDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineGatewayDefinition | undefined;
    set internalValue(value: PipelineGatewayDefinition | undefined);
    private _connectionId?;
    get connectionId(): string;
    set connectionId(value: string);
    resetConnectionId(): void;
    get connectionIdInput(): string | undefined;
    private _connectionName?;
    get connectionName(): string;
    set connectionName(value: string);
    resetConnectionName(): void;
    get connectionNameInput(): string | undefined;
    private _gatewayStorageCatalog?;
    get gatewayStorageCatalog(): string;
    set gatewayStorageCatalog(value: string);
    resetGatewayStorageCatalog(): void;
    get gatewayStorageCatalogInput(): string | undefined;
    private _gatewayStorageName?;
    get gatewayStorageName(): string;
    set gatewayStorageName(value: string);
    resetGatewayStorageName(): void;
    get gatewayStorageNameInput(): string | undefined;
    private _gatewayStorageSchema?;
    get gatewayStorageSchema(): string;
    set gatewayStorageSchema(value: string);
    resetGatewayStorageSchema(): void;
    get gatewayStorageSchemaInput(): string | undefined;
}
export interface PipelineIngestionDefinitionObjectsReportTableConfiguration {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#primary_keys Pipeline#primary_keys}
    */
    readonly primaryKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#salesforce_include_formula_fields Pipeline#salesforce_include_formula_fields}
    */
    readonly salesforceIncludeFormulaFields?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#scd_type Pipeline#scd_type}
    */
    readonly scdType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#sequence_by Pipeline#sequence_by}
    */
    readonly sequenceBy?: string[];
}
export declare function pipelineIngestionDefinitionObjectsReportTableConfigurationToTerraform(struct?: PipelineIngestionDefinitionObjectsReportTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsReportTableConfiguration): any;
export declare function pipelineIngestionDefinitionObjectsReportTableConfigurationToHclTerraform(struct?: PipelineIngestionDefinitionObjectsReportTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsReportTableConfiguration): any;
export declare class PipelineIngestionDefinitionObjectsReportTableConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsReportTableConfiguration | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsReportTableConfiguration | undefined);
    private _primaryKeys?;
    get primaryKeys(): string[];
    set primaryKeys(value: string[]);
    resetPrimaryKeys(): void;
    get primaryKeysInput(): string[] | undefined;
    private _salesforceIncludeFormulaFields?;
    get salesforceIncludeFormulaFields(): boolean | cdktf.IResolvable;
    set salesforceIncludeFormulaFields(value: boolean | cdktf.IResolvable);
    resetSalesforceIncludeFormulaFields(): void;
    get salesforceIncludeFormulaFieldsInput(): boolean | cdktf.IResolvable | undefined;
    private _scdType?;
    get scdType(): string;
    set scdType(value: string);
    resetScdType(): void;
    get scdTypeInput(): string | undefined;
    private _sequenceBy?;
    get sequenceBy(): string[];
    set sequenceBy(value: string[]);
    resetSequenceBy(): void;
    get sequenceByInput(): string[] | undefined;
}
export interface PipelineIngestionDefinitionObjectsReport {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_catalog Pipeline#destination_catalog}
    */
    readonly destinationCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_schema Pipeline#destination_schema}
    */
    readonly destinationSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_table Pipeline#destination_table}
    */
    readonly destinationTable?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_url Pipeline#source_url}
    */
    readonly sourceUrl?: string;
    /**
    * table_configuration block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#table_configuration Pipeline#table_configuration}
    */
    readonly tableConfiguration?: PipelineIngestionDefinitionObjectsReportTableConfiguration;
}
export declare function pipelineIngestionDefinitionObjectsReportToTerraform(struct?: PipelineIngestionDefinitionObjectsReportOutputReference | PipelineIngestionDefinitionObjectsReport): any;
export declare function pipelineIngestionDefinitionObjectsReportToHclTerraform(struct?: PipelineIngestionDefinitionObjectsReportOutputReference | PipelineIngestionDefinitionObjectsReport): any;
export declare class PipelineIngestionDefinitionObjectsReportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsReport | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsReport | undefined);
    private _destinationCatalog?;
    get destinationCatalog(): string;
    set destinationCatalog(value: string);
    resetDestinationCatalog(): void;
    get destinationCatalogInput(): string | undefined;
    private _destinationSchema?;
    get destinationSchema(): string;
    set destinationSchema(value: string);
    resetDestinationSchema(): void;
    get destinationSchemaInput(): string | undefined;
    private _destinationTable?;
    get destinationTable(): string;
    set destinationTable(value: string);
    resetDestinationTable(): void;
    get destinationTableInput(): string | undefined;
    private _sourceUrl?;
    get sourceUrl(): string;
    set sourceUrl(value: string);
    resetSourceUrl(): void;
    get sourceUrlInput(): string | undefined;
    private _tableConfiguration;
    get tableConfiguration(): PipelineIngestionDefinitionObjectsReportTableConfigurationOutputReference;
    putTableConfiguration(value: PipelineIngestionDefinitionObjectsReportTableConfiguration): void;
    resetTableConfiguration(): void;
    get tableConfigurationInput(): PipelineIngestionDefinitionObjectsReportTableConfiguration | undefined;
}
export interface PipelineIngestionDefinitionObjectsSchemaTableConfiguration {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#primary_keys Pipeline#primary_keys}
    */
    readonly primaryKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#salesforce_include_formula_fields Pipeline#salesforce_include_formula_fields}
    */
    readonly salesforceIncludeFormulaFields?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#scd_type Pipeline#scd_type}
    */
    readonly scdType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#sequence_by Pipeline#sequence_by}
    */
    readonly sequenceBy?: string[];
}
export declare function pipelineIngestionDefinitionObjectsSchemaTableConfigurationToTerraform(struct?: PipelineIngestionDefinitionObjectsSchemaTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsSchemaTableConfiguration): any;
export declare function pipelineIngestionDefinitionObjectsSchemaTableConfigurationToHclTerraform(struct?: PipelineIngestionDefinitionObjectsSchemaTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsSchemaTableConfiguration): any;
export declare class PipelineIngestionDefinitionObjectsSchemaTableConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsSchemaTableConfiguration | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsSchemaTableConfiguration | undefined);
    private _primaryKeys?;
    get primaryKeys(): string[];
    set primaryKeys(value: string[]);
    resetPrimaryKeys(): void;
    get primaryKeysInput(): string[] | undefined;
    private _salesforceIncludeFormulaFields?;
    get salesforceIncludeFormulaFields(): boolean | cdktf.IResolvable;
    set salesforceIncludeFormulaFields(value: boolean | cdktf.IResolvable);
    resetSalesforceIncludeFormulaFields(): void;
    get salesforceIncludeFormulaFieldsInput(): boolean | cdktf.IResolvable | undefined;
    private _scdType?;
    get scdType(): string;
    set scdType(value: string);
    resetScdType(): void;
    get scdTypeInput(): string | undefined;
    private _sequenceBy?;
    get sequenceBy(): string[];
    set sequenceBy(value: string[]);
    resetSequenceBy(): void;
    get sequenceByInput(): string[] | undefined;
}
export interface PipelineIngestionDefinitionObjectsSchema {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_catalog Pipeline#destination_catalog}
    */
    readonly destinationCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_schema Pipeline#destination_schema}
    */
    readonly destinationSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_catalog Pipeline#source_catalog}
    */
    readonly sourceCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_schema Pipeline#source_schema}
    */
    readonly sourceSchema?: string;
    /**
    * table_configuration block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#table_configuration Pipeline#table_configuration}
    */
    readonly tableConfiguration?: PipelineIngestionDefinitionObjectsSchemaTableConfiguration;
}
export declare function pipelineIngestionDefinitionObjectsSchemaToTerraform(struct?: PipelineIngestionDefinitionObjectsSchemaOutputReference | PipelineIngestionDefinitionObjectsSchema): any;
export declare function pipelineIngestionDefinitionObjectsSchemaToHclTerraform(struct?: PipelineIngestionDefinitionObjectsSchemaOutputReference | PipelineIngestionDefinitionObjectsSchema): any;
export declare class PipelineIngestionDefinitionObjectsSchemaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsSchema | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsSchema | undefined);
    private _destinationCatalog?;
    get destinationCatalog(): string;
    set destinationCatalog(value: string);
    resetDestinationCatalog(): void;
    get destinationCatalogInput(): string | undefined;
    private _destinationSchema?;
    get destinationSchema(): string;
    set destinationSchema(value: string);
    resetDestinationSchema(): void;
    get destinationSchemaInput(): string | undefined;
    private _sourceCatalog?;
    get sourceCatalog(): string;
    set sourceCatalog(value: string);
    resetSourceCatalog(): void;
    get sourceCatalogInput(): string | undefined;
    private _sourceSchema?;
    get sourceSchema(): string;
    set sourceSchema(value: string);
    resetSourceSchema(): void;
    get sourceSchemaInput(): string | undefined;
    private _tableConfiguration;
    get tableConfiguration(): PipelineIngestionDefinitionObjectsSchemaTableConfigurationOutputReference;
    putTableConfiguration(value: PipelineIngestionDefinitionObjectsSchemaTableConfiguration): void;
    resetTableConfiguration(): void;
    get tableConfigurationInput(): PipelineIngestionDefinitionObjectsSchemaTableConfiguration | undefined;
}
export interface PipelineIngestionDefinitionObjectsTableTableConfiguration {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#primary_keys Pipeline#primary_keys}
    */
    readonly primaryKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#salesforce_include_formula_fields Pipeline#salesforce_include_formula_fields}
    */
    readonly salesforceIncludeFormulaFields?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#scd_type Pipeline#scd_type}
    */
    readonly scdType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#sequence_by Pipeline#sequence_by}
    */
    readonly sequenceBy?: string[];
}
export declare function pipelineIngestionDefinitionObjectsTableTableConfigurationToTerraform(struct?: PipelineIngestionDefinitionObjectsTableTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsTableTableConfiguration): any;
export declare function pipelineIngestionDefinitionObjectsTableTableConfigurationToHclTerraform(struct?: PipelineIngestionDefinitionObjectsTableTableConfigurationOutputReference | PipelineIngestionDefinitionObjectsTableTableConfiguration): any;
export declare class PipelineIngestionDefinitionObjectsTableTableConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsTableTableConfiguration | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsTableTableConfiguration | undefined);
    private _primaryKeys?;
    get primaryKeys(): string[];
    set primaryKeys(value: string[]);
    resetPrimaryKeys(): void;
    get primaryKeysInput(): string[] | undefined;
    private _salesforceIncludeFormulaFields?;
    get salesforceIncludeFormulaFields(): boolean | cdktf.IResolvable;
    set salesforceIncludeFormulaFields(value: boolean | cdktf.IResolvable);
    resetSalesforceIncludeFormulaFields(): void;
    get salesforceIncludeFormulaFieldsInput(): boolean | cdktf.IResolvable | undefined;
    private _scdType?;
    get scdType(): string;
    set scdType(value: string);
    resetScdType(): void;
    get scdTypeInput(): string | undefined;
    private _sequenceBy?;
    get sequenceBy(): string[];
    set sequenceBy(value: string[]);
    resetSequenceBy(): void;
    get sequenceByInput(): string[] | undefined;
}
export interface PipelineIngestionDefinitionObjectsTable {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_catalog Pipeline#destination_catalog}
    */
    readonly destinationCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_schema Pipeline#destination_schema}
    */
    readonly destinationSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#destination_table Pipeline#destination_table}
    */
    readonly destinationTable?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_catalog Pipeline#source_catalog}
    */
    readonly sourceCatalog?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_schema Pipeline#source_schema}
    */
    readonly sourceSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#source_table Pipeline#source_table}
    */
    readonly sourceTable?: string;
    /**
    * table_configuration block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#table_configuration Pipeline#table_configuration}
    */
    readonly tableConfiguration?: PipelineIngestionDefinitionObjectsTableTableConfiguration;
}
export declare function pipelineIngestionDefinitionObjectsTableToTerraform(struct?: PipelineIngestionDefinitionObjectsTableOutputReference | PipelineIngestionDefinitionObjectsTable): any;
export declare function pipelineIngestionDefinitionObjectsTableToHclTerraform(struct?: PipelineIngestionDefinitionObjectsTableOutputReference | PipelineIngestionDefinitionObjectsTable): any;
export declare class PipelineIngestionDefinitionObjectsTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionObjectsTable | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjectsTable | undefined);
    private _destinationCatalog?;
    get destinationCatalog(): string;
    set destinationCatalog(value: string);
    resetDestinationCatalog(): void;
    get destinationCatalogInput(): string | undefined;
    private _destinationSchema?;
    get destinationSchema(): string;
    set destinationSchema(value: string);
    resetDestinationSchema(): void;
    get destinationSchemaInput(): string | undefined;
    private _destinationTable?;
    get destinationTable(): string;
    set destinationTable(value: string);
    resetDestinationTable(): void;
    get destinationTableInput(): string | undefined;
    private _sourceCatalog?;
    get sourceCatalog(): string;
    set sourceCatalog(value: string);
    resetSourceCatalog(): void;
    get sourceCatalogInput(): string | undefined;
    private _sourceSchema?;
    get sourceSchema(): string;
    set sourceSchema(value: string);
    resetSourceSchema(): void;
    get sourceSchemaInput(): string | undefined;
    private _sourceTable?;
    get sourceTable(): string;
    set sourceTable(value: string);
    resetSourceTable(): void;
    get sourceTableInput(): string | undefined;
    private _tableConfiguration;
    get tableConfiguration(): PipelineIngestionDefinitionObjectsTableTableConfigurationOutputReference;
    putTableConfiguration(value: PipelineIngestionDefinitionObjectsTableTableConfiguration): void;
    resetTableConfiguration(): void;
    get tableConfigurationInput(): PipelineIngestionDefinitionObjectsTableTableConfiguration | undefined;
}
export interface PipelineIngestionDefinitionObjects {
    /**
    * report block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#report Pipeline#report}
    */
    readonly report?: PipelineIngestionDefinitionObjectsReport;
    /**
    * schema block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#schema Pipeline#schema}
    */
    readonly schema?: PipelineIngestionDefinitionObjectsSchema;
    /**
    * table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#table Pipeline#table}
    */
    readonly table?: PipelineIngestionDefinitionObjectsTable;
}
export declare function pipelineIngestionDefinitionObjectsToTerraform(struct?: PipelineIngestionDefinitionObjects | cdktf.IResolvable): any;
export declare function pipelineIngestionDefinitionObjectsToHclTerraform(struct?: PipelineIngestionDefinitionObjects | cdktf.IResolvable): any;
export declare class PipelineIngestionDefinitionObjectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineIngestionDefinitionObjects | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineIngestionDefinitionObjects | cdktf.IResolvable | undefined);
    private _report;
    get report(): PipelineIngestionDefinitionObjectsReportOutputReference;
    putReport(value: PipelineIngestionDefinitionObjectsReport): void;
    resetReport(): void;
    get reportInput(): PipelineIngestionDefinitionObjectsReport | undefined;
    private _schema;
    get schema(): PipelineIngestionDefinitionObjectsSchemaOutputReference;
    putSchema(value: PipelineIngestionDefinitionObjectsSchema): void;
    resetSchema(): void;
    get schemaInput(): PipelineIngestionDefinitionObjectsSchema | undefined;
    private _table;
    get table(): PipelineIngestionDefinitionObjectsTableOutputReference;
    putTable(value: PipelineIngestionDefinitionObjectsTable): void;
    resetTable(): void;
    get tableInput(): PipelineIngestionDefinitionObjectsTable | undefined;
}
export declare class PipelineIngestionDefinitionObjectsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineIngestionDefinitionObjects[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineIngestionDefinitionObjectsOutputReference;
}
export interface PipelineIngestionDefinitionTableConfiguration {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#primary_keys Pipeline#primary_keys}
    */
    readonly primaryKeys?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#salesforce_include_formula_fields Pipeline#salesforce_include_formula_fields}
    */
    readonly salesforceIncludeFormulaFields?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#scd_type Pipeline#scd_type}
    */
    readonly scdType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#sequence_by Pipeline#sequence_by}
    */
    readonly sequenceBy?: string[];
}
export declare function pipelineIngestionDefinitionTableConfigurationToTerraform(struct?: PipelineIngestionDefinitionTableConfigurationOutputReference | PipelineIngestionDefinitionTableConfiguration): any;
export declare function pipelineIngestionDefinitionTableConfigurationToHclTerraform(struct?: PipelineIngestionDefinitionTableConfigurationOutputReference | PipelineIngestionDefinitionTableConfiguration): any;
export declare class PipelineIngestionDefinitionTableConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinitionTableConfiguration | undefined;
    set internalValue(value: PipelineIngestionDefinitionTableConfiguration | undefined);
    private _primaryKeys?;
    get primaryKeys(): string[];
    set primaryKeys(value: string[]);
    resetPrimaryKeys(): void;
    get primaryKeysInput(): string[] | undefined;
    private _salesforceIncludeFormulaFields?;
    get salesforceIncludeFormulaFields(): boolean | cdktf.IResolvable;
    set salesforceIncludeFormulaFields(value: boolean | cdktf.IResolvable);
    resetSalesforceIncludeFormulaFields(): void;
    get salesforceIncludeFormulaFieldsInput(): boolean | cdktf.IResolvable | undefined;
    private _scdType?;
    get scdType(): string;
    set scdType(value: string);
    resetScdType(): void;
    get scdTypeInput(): string | undefined;
    private _sequenceBy?;
    get sequenceBy(): string[];
    set sequenceBy(value: string[]);
    resetSequenceBy(): void;
    get sequenceByInput(): string[] | undefined;
}
export interface PipelineIngestionDefinition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#connection_name Pipeline#connection_name}
    */
    readonly connectionName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#ingestion_gateway_id Pipeline#ingestion_gateway_id}
    */
    readonly ingestionGatewayId?: string;
    /**
    * objects block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#objects Pipeline#objects}
    */
    readonly objects?: PipelineIngestionDefinitionObjects[] | cdktf.IResolvable;
    /**
    * table_configuration block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#table_configuration Pipeline#table_configuration}
    */
    readonly tableConfiguration?: PipelineIngestionDefinitionTableConfiguration;
}
export declare function pipelineIngestionDefinitionToTerraform(struct?: PipelineIngestionDefinitionOutputReference | PipelineIngestionDefinition): any;
export declare function pipelineIngestionDefinitionToHclTerraform(struct?: PipelineIngestionDefinitionOutputReference | PipelineIngestionDefinition): any;
export declare class PipelineIngestionDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineIngestionDefinition | undefined;
    set internalValue(value: PipelineIngestionDefinition | undefined);
    private _connectionName?;
    get connectionName(): string;
    set connectionName(value: string);
    resetConnectionName(): void;
    get connectionNameInput(): string | undefined;
    private _ingestionGatewayId?;
    get ingestionGatewayId(): string;
    set ingestionGatewayId(value: string);
    resetIngestionGatewayId(): void;
    get ingestionGatewayIdInput(): string | undefined;
    private _objects;
    get objects(): PipelineIngestionDefinitionObjectsList;
    putObjects(value: PipelineIngestionDefinitionObjects[] | cdktf.IResolvable): void;
    resetObjects(): void;
    get objectsInput(): cdktf.IResolvable | PipelineIngestionDefinitionObjects[] | undefined;
    private _tableConfiguration;
    get tableConfiguration(): PipelineIngestionDefinitionTableConfigurationOutputReference;
    putTableConfiguration(value: PipelineIngestionDefinitionTableConfiguration): void;
    resetTableConfiguration(): void;
    get tableConfigurationInput(): PipelineIngestionDefinitionTableConfiguration | undefined;
}
export interface PipelineLatestUpdates {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#creation_time Pipeline#creation_time}
    */
    readonly creationTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#state Pipeline#state}
    */
    readonly state?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#update_id Pipeline#update_id}
    */
    readonly updateId?: string;
}
export declare function pipelineLatestUpdatesToTerraform(struct?: PipelineLatestUpdates | cdktf.IResolvable): any;
export declare function pipelineLatestUpdatesToHclTerraform(struct?: PipelineLatestUpdates | cdktf.IResolvable): any;
export declare class PipelineLatestUpdatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineLatestUpdates | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineLatestUpdates | cdktf.IResolvable | undefined);
    private _creationTime?;
    get creationTime(): string;
    set creationTime(value: string);
    resetCreationTime(): void;
    get creationTimeInput(): string | undefined;
    private _state?;
    get state(): string;
    set state(value: string);
    resetState(): void;
    get stateInput(): string | undefined;
    private _updateId?;
    get updateId(): string;
    set updateId(value: string);
    resetUpdateId(): void;
    get updateIdInput(): string | undefined;
}
export declare class PipelineLatestUpdatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineLatestUpdates[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineLatestUpdatesOutputReference;
}
export interface PipelineLibraryFile {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#path Pipeline#path}
    */
    readonly path?: string;
}
export declare function pipelineLibraryFileToTerraform(struct?: PipelineLibraryFileOutputReference | PipelineLibraryFile): any;
export declare function pipelineLibraryFileToHclTerraform(struct?: PipelineLibraryFileOutputReference | PipelineLibraryFile): any;
export declare class PipelineLibraryFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineLibraryFile | undefined;
    set internalValue(value: PipelineLibraryFile | undefined);
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
}
export interface PipelineLibraryMaven {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#coordinates Pipeline#coordinates}
    */
    readonly coordinates: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#exclusions Pipeline#exclusions}
    */
    readonly exclusions?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#repo Pipeline#repo}
    */
    readonly repo?: string;
}
export declare function pipelineLibraryMavenToTerraform(struct?: PipelineLibraryMavenOutputReference | PipelineLibraryMaven): any;
export declare function pipelineLibraryMavenToHclTerraform(struct?: PipelineLibraryMavenOutputReference | PipelineLibraryMaven): any;
export declare class PipelineLibraryMavenOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineLibraryMaven | undefined;
    set internalValue(value: PipelineLibraryMaven | undefined);
    private _coordinates?;
    get coordinates(): string;
    set coordinates(value: string);
    get coordinatesInput(): string | undefined;
    private _exclusions?;
    get exclusions(): string[];
    set exclusions(value: string[]);
    resetExclusions(): void;
    get exclusionsInput(): string[] | undefined;
    private _repo?;
    get repo(): string;
    set repo(value: string);
    resetRepo(): void;
    get repoInput(): string | undefined;
}
export interface PipelineLibraryNotebook {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#path Pipeline#path}
    */
    readonly path?: string;
}
export declare function pipelineLibraryNotebookToTerraform(struct?: PipelineLibraryNotebookOutputReference | PipelineLibraryNotebook): any;
export declare function pipelineLibraryNotebookToHclTerraform(struct?: PipelineLibraryNotebookOutputReference | PipelineLibraryNotebook): any;
export declare class PipelineLibraryNotebookOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineLibraryNotebook | undefined;
    set internalValue(value: PipelineLibraryNotebook | undefined);
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
}
export interface PipelineLibrary {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#jar Pipeline#jar}
    */
    readonly jar?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#whl Pipeline#whl}
    */
    readonly whl?: string;
    /**
    * file block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#file Pipeline#file}
    */
    readonly file?: PipelineLibraryFile;
    /**
    * maven block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#maven Pipeline#maven}
    */
    readonly maven?: PipelineLibraryMaven;
    /**
    * notebook block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#notebook Pipeline#notebook}
    */
    readonly notebook?: PipelineLibraryNotebook;
}
export declare function pipelineLibraryToTerraform(struct?: PipelineLibrary | cdktf.IResolvable): any;
export declare function pipelineLibraryToHclTerraform(struct?: PipelineLibrary | cdktf.IResolvable): any;
export declare class PipelineLibraryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineLibrary | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineLibrary | cdktf.IResolvable | undefined);
    private _jar?;
    get jar(): string;
    set jar(value: string);
    resetJar(): void;
    get jarInput(): string | undefined;
    private _whl?;
    get whl(): string;
    set whl(value: string);
    resetWhl(): void;
    get whlInput(): string | undefined;
    private _file;
    get file(): PipelineLibraryFileOutputReference;
    putFile(value: PipelineLibraryFile): void;
    resetFile(): void;
    get fileInput(): PipelineLibraryFile | undefined;
    private _maven;
    get maven(): PipelineLibraryMavenOutputReference;
    putMaven(value: PipelineLibraryMaven): void;
    resetMaven(): void;
    get mavenInput(): PipelineLibraryMaven | undefined;
    private _notebook;
    get notebook(): PipelineLibraryNotebookOutputReference;
    putNotebook(value: PipelineLibraryNotebook): void;
    resetNotebook(): void;
    get notebookInput(): PipelineLibraryNotebook | undefined;
}
export declare class PipelineLibraryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineLibrary[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineLibraryOutputReference;
}
export interface PipelineNotification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#alerts Pipeline#alerts}
    */
    readonly alerts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#email_recipients Pipeline#email_recipients}
    */
    readonly emailRecipients?: string[];
}
export declare function pipelineNotificationToTerraform(struct?: PipelineNotification | cdktf.IResolvable): any;
export declare function pipelineNotificationToHclTerraform(struct?: PipelineNotification | cdktf.IResolvable): any;
export declare class PipelineNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PipelineNotification | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineNotification | cdktf.IResolvable | undefined);
    private _alerts?;
    get alerts(): string[];
    set alerts(value: string[]);
    resetAlerts(): void;
    get alertsInput(): string[] | undefined;
    private _emailRecipients?;
    get emailRecipients(): string[];
    set emailRecipients(value: string[]);
    resetEmailRecipients(): void;
    get emailRecipientsInput(): string[] | undefined;
}
export declare class PipelineNotificationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PipelineNotification[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PipelineNotificationOutputReference;
}
export interface PipelineRestartWindow {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#days_of_week Pipeline#days_of_week}
    */
    readonly daysOfWeek?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#start_hour Pipeline#start_hour}
    */
    readonly startHour: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#time_zone_id Pipeline#time_zone_id}
    */
    readonly timeZoneId?: string;
}
export declare function pipelineRestartWindowToTerraform(struct?: PipelineRestartWindowOutputReference | PipelineRestartWindow): any;
export declare function pipelineRestartWindowToHclTerraform(struct?: PipelineRestartWindowOutputReference | PipelineRestartWindow): any;
export declare class PipelineRestartWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineRestartWindow | undefined;
    set internalValue(value: PipelineRestartWindow | undefined);
    private _daysOfWeek?;
    get daysOfWeek(): string[];
    set daysOfWeek(value: string[]);
    resetDaysOfWeek(): void;
    get daysOfWeekInput(): string[] | undefined;
    private _startHour?;
    get startHour(): number;
    set startHour(value: number);
    get startHourInput(): number | undefined;
    private _timeZoneId?;
    get timeZoneId(): string;
    set timeZoneId(value: string);
    resetTimeZoneId(): void;
    get timeZoneIdInput(): string | undefined;
}
export interface PipelineRunAs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#service_principal_name Pipeline#service_principal_name}
    */
    readonly servicePrincipalName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#user_name Pipeline#user_name}
    */
    readonly userName?: string;
}
export declare function pipelineRunAsToTerraform(struct?: PipelineRunAsOutputReference | PipelineRunAs): any;
export declare function pipelineRunAsToHclTerraform(struct?: PipelineRunAsOutputReference | PipelineRunAs): any;
export declare class PipelineRunAsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineRunAs | undefined;
    set internalValue(value: PipelineRunAs | undefined);
    private _servicePrincipalName?;
    get servicePrincipalName(): string;
    set servicePrincipalName(value: string);
    resetServicePrincipalName(): void;
    get servicePrincipalNameInput(): string | undefined;
    private _userName?;
    get userName(): string;
    set userName(value: string);
    resetUserName(): void;
    get userNameInput(): string | undefined;
}
export interface PipelineTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#default Pipeline#default}
    */
    readonly default?: string;
}
export declare function pipelineTimeoutsToTerraform(struct?: PipelineTimeouts | cdktf.IResolvable): any;
export declare function pipelineTimeoutsToHclTerraform(struct?: PipelineTimeouts | cdktf.IResolvable): any;
export declare class PipelineTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: PipelineTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
export interface PipelineTriggerCron {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#quartz_cron_schedule Pipeline#quartz_cron_schedule}
    */
    readonly quartzCronSchedule?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#timezone_id Pipeline#timezone_id}
    */
    readonly timezoneId?: string;
}
export declare function pipelineTriggerCronToTerraform(struct?: PipelineTriggerCronOutputReference | PipelineTriggerCron): any;
export declare function pipelineTriggerCronToHclTerraform(struct?: PipelineTriggerCronOutputReference | PipelineTriggerCron): any;
export declare class PipelineTriggerCronOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineTriggerCron | undefined;
    set internalValue(value: PipelineTriggerCron | undefined);
    private _quartzCronSchedule?;
    get quartzCronSchedule(): string;
    set quartzCronSchedule(value: string);
    resetQuartzCronSchedule(): void;
    get quartzCronScheduleInput(): string | undefined;
    private _timezoneId?;
    get timezoneId(): string;
    set timezoneId(value: string);
    resetTimezoneId(): void;
    get timezoneIdInput(): string | undefined;
}
export interface PipelineTriggerManual {
}
export declare function pipelineTriggerManualToTerraform(struct?: PipelineTriggerManualOutputReference | PipelineTriggerManual): any;
export declare function pipelineTriggerManualToHclTerraform(struct?: PipelineTriggerManualOutputReference | PipelineTriggerManual): any;
export declare class PipelineTriggerManualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineTriggerManual | undefined;
    set internalValue(value: PipelineTriggerManual | undefined);
}
export interface PipelineTrigger {
    /**
    * cron block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#cron Pipeline#cron}
    */
    readonly cron?: PipelineTriggerCron;
    /**
    * manual block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#manual Pipeline#manual}
    */
    readonly manual?: PipelineTriggerManual;
}
export declare function pipelineTriggerToTerraform(struct?: PipelineTriggerOutputReference | PipelineTrigger): any;
export declare function pipelineTriggerToHclTerraform(struct?: PipelineTriggerOutputReference | PipelineTrigger): any;
export declare class PipelineTriggerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PipelineTrigger | undefined;
    set internalValue(value: PipelineTrigger | undefined);
    private _cron;
    get cron(): PipelineTriggerCronOutputReference;
    putCron(value: PipelineTriggerCron): void;
    resetCron(): void;
    get cronInput(): PipelineTriggerCron | undefined;
    private _manual;
    get manual(): PipelineTriggerManualOutputReference;
    putManual(value: PipelineTriggerManual): void;
    resetManual(): void;
    get manualInput(): PipelineTriggerManual | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline databricks_pipeline}
*/
export declare class Pipeline extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_pipeline";
    /**
    * Generates CDKTF code for importing a Pipeline resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the Pipeline to import
    * @param importFromId The id of the existing Pipeline that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the Pipeline to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.72.0/docs/resources/pipeline databricks_pipeline} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options PipelineConfig = {}
    */
    constructor(scope: Construct, id: string, config?: PipelineConfig);
    private _allowDuplicateNames?;
    get allowDuplicateNames(): boolean | cdktf.IResolvable;
    set allowDuplicateNames(value: boolean | cdktf.IResolvable);
    resetAllowDuplicateNames(): void;
    get allowDuplicateNamesInput(): boolean | cdktf.IResolvable | undefined;
    private _budgetPolicyId?;
    get budgetPolicyId(): string;
    set budgetPolicyId(value: string);
    resetBudgetPolicyId(): void;
    get budgetPolicyIdInput(): string | undefined;
    private _catalog?;
    get catalog(): string;
    set catalog(value: string);
    resetCatalog(): void;
    get catalogInput(): string | undefined;
    private _cause?;
    get cause(): string;
    set cause(value: string);
    resetCause(): void;
    get causeInput(): string | undefined;
    private _channel?;
    get channel(): string;
    set channel(value: string);
    resetChannel(): void;
    get channelInput(): string | undefined;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _configuration?;
    get configuration(): {
        [key: string]: string;
    };
    set configuration(value: {
        [key: string]: string;
    });
    resetConfiguration(): void;
    get configurationInput(): {
        [key: string]: string;
    } | undefined;
    private _continuous?;
    get continuous(): boolean | cdktf.IResolvable;
    set continuous(value: boolean | cdktf.IResolvable);
    resetContinuous(): void;
    get continuousInput(): boolean | cdktf.IResolvable | undefined;
    private _creatorUserName?;
    get creatorUserName(): string;
    set creatorUserName(value: string);
    resetCreatorUserName(): void;
    get creatorUserNameInput(): string | undefined;
    private _development?;
    get development(): boolean | cdktf.IResolvable;
    set development(value: boolean | cdktf.IResolvable);
    resetDevelopment(): void;
    get developmentInput(): boolean | cdktf.IResolvable | undefined;
    private _edition?;
    get edition(): string;
    set edition(value: string);
    resetEdition(): void;
    get editionInput(): string | undefined;
    private _expectedLastModified?;
    get expectedLastModified(): number;
    set expectedLastModified(value: number);
    resetExpectedLastModified(): void;
    get expectedLastModifiedInput(): number | undefined;
    private _health?;
    get health(): string;
    set health(value: string);
    resetHealth(): void;
    get healthInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _lastModified?;
    get lastModified(): number;
    set lastModified(value: number);
    resetLastModified(): void;
    get lastModifiedInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _photon?;
    get photon(): boolean | cdktf.IResolvable;
    set photon(value: boolean | cdktf.IResolvable);
    resetPhoton(): void;
    get photonInput(): boolean | cdktf.IResolvable | undefined;
    private _runAsUserName?;
    get runAsUserName(): string;
    set runAsUserName(value: string);
    resetRunAsUserName(): void;
    get runAsUserNameInput(): string | undefined;
    private _schema?;
    get schema(): string;
    set schema(value: string);
    resetSchema(): void;
    get schemaInput(): string | undefined;
    private _serverless?;
    get serverless(): boolean | cdktf.IResolvable;
    set serverless(value: boolean | cdktf.IResolvable);
    resetServerless(): void;
    get serverlessInput(): boolean | cdktf.IResolvable | undefined;
    private _state?;
    get state(): string;
    set state(value: string);
    resetState(): void;
    get stateInput(): string | undefined;
    private _storage?;
    get storage(): string;
    set storage(value: string);
    resetStorage(): void;
    get storageInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    private _cluster;
    get cluster(): PipelineClusterList;
    putCluster(value: PipelineCluster[] | cdktf.IResolvable): void;
    resetCluster(): void;
    get clusterInput(): cdktf.IResolvable | PipelineCluster[] | undefined;
    private _deployment;
    get deployment(): PipelineDeploymentOutputReference;
    putDeployment(value: PipelineDeployment): void;
    resetDeployment(): void;
    get deploymentInput(): PipelineDeployment | undefined;
    private _eventLog;
    get eventLog(): PipelineEventLogOutputReference;
    putEventLog(value: PipelineEventLog): void;
    resetEventLog(): void;
    get eventLogInput(): PipelineEventLog | undefined;
    private _filters;
    get filters(): PipelineFiltersOutputReference;
    putFilters(value: PipelineFilters): void;
    resetFilters(): void;
    get filtersInput(): PipelineFilters | undefined;
    private _gatewayDefinition;
    get gatewayDefinition(): PipelineGatewayDefinitionOutputReference;
    putGatewayDefinition(value: PipelineGatewayDefinition): void;
    resetGatewayDefinition(): void;
    get gatewayDefinitionInput(): PipelineGatewayDefinition | undefined;
    private _ingestionDefinition;
    get ingestionDefinition(): PipelineIngestionDefinitionOutputReference;
    putIngestionDefinition(value: PipelineIngestionDefinition): void;
    resetIngestionDefinition(): void;
    get ingestionDefinitionInput(): PipelineIngestionDefinition | undefined;
    private _latestUpdates;
    get latestUpdates(): PipelineLatestUpdatesList;
    putLatestUpdates(value: PipelineLatestUpdates[] | cdktf.IResolvable): void;
    resetLatestUpdates(): void;
    get latestUpdatesInput(): cdktf.IResolvable | PipelineLatestUpdates[] | undefined;
    private _library;
    get library(): PipelineLibraryList;
    putLibrary(value: PipelineLibrary[] | cdktf.IResolvable): void;
    resetLibrary(): void;
    get libraryInput(): cdktf.IResolvable | PipelineLibrary[] | undefined;
    private _notification;
    get notification(): PipelineNotificationList;
    putNotification(value: PipelineNotification[] | cdktf.IResolvable): void;
    resetNotification(): void;
    get notificationInput(): cdktf.IResolvable | PipelineNotification[] | undefined;
    private _restartWindow;
    get restartWindow(): PipelineRestartWindowOutputReference;
    putRestartWindow(value: PipelineRestartWindow): void;
    resetRestartWindow(): void;
    get restartWindowInput(): PipelineRestartWindow | undefined;
    private _runAs;
    get runAs(): PipelineRunAsOutputReference;
    putRunAs(value: PipelineRunAs): void;
    resetRunAs(): void;
    get runAsInput(): PipelineRunAs | undefined;
    private _timeouts;
    get timeouts(): PipelineTimeoutsOutputReference;
    putTimeouts(value: PipelineTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | PipelineTimeouts | undefined;
    private _trigger;
    get trigger(): PipelineTriggerOutputReference;
    putTrigger(value: PipelineTrigger): void;
    resetTrigger(): void;
    get triggerInput(): PipelineTrigger | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
